program Project1;

{$R-}

uses
  SysUtils,Windows,EZSecCMDc;

{$IFDEF WIN32}
type
    Int16   = SmallInt;
    SString = ShortString;
{$ELSE}
type
    Int16   = Integer;
{$ENDIF}

const
  Nez = 1.872378645;
  Lez = 3.734567025;
  Aez = 1.046672656;
  Expo1 = 1E8;
  Expo2 = 1E9;
  Expo3 = 1E-9;
  Chb = 'hGRedcgtrdtJYTF76543KYFgbjTY57';
////////////////////////////////////////////////////////////////////////////////
function IsDebuggerAttached:boolean;
asm
  mov eax, fs:[$18]
  mov eax, dword ptr [eax + $30]
  mov eax, dword ptr [eax]
  and eax, $00010000
  shr eax, 16
end;
//------------------------------------------------------------------------------
function RandText(Len:integer):string;
var
  i,j : integer;
begin
  SetLength(Result,Len);
  for i := 1 to Len do begin
    j  := (Random(Trunc(Time*24*3600*1000))) mod 61;
    if (j <= 9) then Result[i] := Chr(48 + j)
    else if (j > 9) and (j < 35) then Result[i] := Chr(56 + j)
    else if (j > 34) then Result[i] := Chr(62 + j);
  end;
end;
//------------------------------------------------------------------------------
function GetRandTarget:string;
var
  I : integer;
  //--------
  function GetRootDir2: string;
  var
    ph: PChar;
  begin
    GetMem(ph, 255);
    GetSystemDirectory(ph, 254);
    Result := (Copy(Strpas(ph), 1, 2));
    Freemem(ph);
  end;
  //--------
  function Equal(Pa:string):boolean;
  begin
     If UpperCase(ExtractFilePath(ParamStr(0))+'\') = UpperCase(Pa) then Result := True
     else Result := False;
     if not DirectoryExists(Pa) then Result := True;
  end;
  //--------
  function GetWinDir: string;
  var
    dir: array [0..MAX_PATH] of Char;
  begin
    GetWindowsDirectory(dir, MAX_PATH);
    Result := StrPas(dir);
    if Equal(Result) then Result := GetRootDir2;
  end;
  //--------
  function GetSysDir: string;
  var
    dir: array [0..MAX_PATH] of Char;
  begin
    GetSystemDirectory(dir, MAX_PATH);
    Result := StrPas(dir);
    if Equal(Result) then Result := GetWinDir;
  end;
  //--------
  function GetTempDir: string;
  var
    Buffer: array[0..MAX_PATH] of Char;
  begin
    GetTempPath(SizeOf(Buffer) - 1, Buffer);
    Result := StrPas(Buffer);
    if Equal(Result) then Result := GetSysDir;
  end;
  //--------
  function GetRootDir: string;
  var
    ph: PChar;
  begin
    GetMem(ph, 255);
    GetSystemDirectory(ph, 254);
    Result := (Copy(Strpas(ph), 1, 2));
    Freemem(ph);
    if Equal(Result) then Result := GetTempDir;
  end;
  //--------
begin
  Result := ExtractFilePath(ParamStr(0));
  I := (Trunc(Now*24*3600)) mod 4;
  case I of
     0 : Result := GetWinDir+'\';
     1 : Result := GetSysDir+'\';
     2 : Result := GetTempDir+'\';
     3 : Result := GetRootDir+'\';
  end;
end;
//------------------------------------------------------------------------------
{$WARNINGS OFF}
procedure DeCompEnc(FromF,ToF:string);
const
  Neze = 1.882737673;
  Leze = 3.775727748;
  Aeze = 1.077482881;
  EXIT_OK       = 0;
  EXIT_FAILED   = 1;
  N	        = 4096;
  F	        = 60;
  THRESHOLD	= 2;
  NUL           = N;
  N_CHAR        = (256 - THRESHOLD + F);
  T 	        = (N_CHAR * 2 - 1);
  R 	        = (T - 1);
  MAX_FREQ      = $8000;

  p_len : Array[0..63] of BYTE =
       ($03, $04, $04, $04, $05, $05, $05, $05,	$05, $05, $05, $05, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,	$07, $07, $07, $07, $07, $07, $07, $07,
	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$08, $08, $08, $08, $08, $08, $08, $08,	$08, $08, $08, $08, $08, $08, $08, $08);
  p_code : Array [0..63] OF BYTE =
       ($00, $20, $30, $40, $50, $58, $60, $68,	$70, $78, $80, $88, $90, $94, $98, $9C,	$A0, $A4, $A8, $AC, $B0, $B4, $B8, $BC,	$C0, $C2, $C4, $C6, $C8, $CA, $CC, $CE,
	$D0, $D2, $D4, $D6, $D8, $DA, $DC, $DE,	$E0, $E2, $E4, $E6, $E8, $EA, $EC, $EE,	$F0, $F1, $F2, $F3, $F4, $F5, $F6, $F7,	$F8, $F9, $FA, $FB, $FC, $FD, $FE, $FF);
  d_code: Array [0..255] OF BYTE =
       ($00, $00, $00, $00, $00, $00, $00, $00,	$00, $00, $00, $00, $00, $00, $00, $00,	$00, $00, $00, $00, $00, $00, $00, $00,	$00, $00, $00, $00, $00, $00, $00, $00,	$01, $01, $01, $01, $01, $01, $01, $01,	$01, $01, $01, $01, $01, $01, $01, $01,	$02, $02, $02, $02, $02, $02, $02, $02,	$02, $02, $02, $02, $02, $02, $02, $02,
	$03, $03, $03, $03, $03, $03, $03, $03,	$03, $03, $03, $03, $03, $03, $03, $03,	$04, $04, $04, $04, $04, $04, $04, $04,	$05, $05, $05, $05, $05, $05, $05, $05,	$06, $06, $06, $06, $06, $06, $06, $06,	$07, $07, $07, $07, $07, $07, $07, $07,	$08, $08, $08, $08, $08, $08, $08, $08,	$09, $09, $09, $09, $09, $09, $09, $09,
	$0A, $0A, $0A, $0A, $0A, $0A, $0A, $0A,	$0B, $0B, $0B, $0B, $0B, $0B, $0B, $0B,	$0C, $0C, $0C, $0C, $0D, $0D, $0D, $0D,	$0E, $0E, $0E, $0E, $0F, $0F, $0F, $0F,	$10, $10, $10, $10, $11, $11, $11, $11,	$12, $12, $12, $12, $13, $13, $13, $13,	$14, $14, $14, $14, $15, $15, $15, $15,	$16, $16, $16, $16, $17, $17, $17, $17,
	$18, $18, $19, $19, $1A, $1A, $1B, $1B,	$1C, $1C, $1D, $1D, $1E, $1E, $1F, $1F,	$20, $20, $21, $21, $22, $22, $23, $23,	$24, $24, $25, $25, $26, $26, $27, $27,	$28, $28, $29, $29, $2A, $2A, $2B, $2B,	$2C, $2C, $2D, $2D, $2E, $2E, $2F, $2F,	$30, $31, $32, $33, $34, $35, $36, $37,	$38, $39, $3A, $3B, $3C, $3D, $3E, $3F);
 d_len: Array[0..255] of BYTE =
       ($03, $03, $03, $03, $03, $03, $03, $03,	$03, $03, $03, $03, $03, $03, $03, $03,	$03, $03, $03, $03, $03, $03, $03, $03,	$03, $03, $03, $03, $03, $03, $03, $03,	$04, $04, $04, $04, $04, $04, $04, $04,	$04, $04, $04, $04, $04, $04, $04, $04,	$04, $04, $04, $04, $04, $04, $04, $04,	$04, $04, $04, $04, $04, $04, $04, $04,
	$04, $04, $04, $04, $04, $04, $04, $04,	$04, $04, $04, $04, $04, $04, $04, $04,	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,
	$05, $05, $05, $05, $05, $05, $05, $05,	$05, $05, $05, $05, $05, $05, $05, $05,	$06, $06, $06, $06, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,	$06, $06, $06, $06, $06, $06, $06, $06,
	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$07, $07, $07, $07, $07, $07, $07, $07,	$08, $08, $08, $08, $08, $08, $08, $08,	$08, $08, $08, $08, $08, $08, $08, $08);

  BufferMaxSize  = 32768;
  BufferMax      = BufferMaxSize-1;

  ChunkSize = 32768;
  IOBufSize = (ChunkSize + 16);

type
  BufferIndex    = 0..BufferMax + 15;
  BufferSize     = 0..BufferMaxSize;
  BufferArray    = ARRAY [BufferIndex] OF BYTE;
  BufferPtr      = ^BufferArray;

  LZHBuf  = Array[1..ChunkSize] OF BYTE;
  PLZHBuf = ^LZHBuf;

  Freqtype = Array[0..T] OF WORD;
  FreqPtr = ^freqtype;
  PntrType = Array[0..PRED(T+N_Char)] OF Int16;
  pntrPtr = ^pntrType;
  SonType = Array[0..PRED(T)] OF Int16;
  SonPtr = ^SonType;

  TextBufType = Array[0..N+F-2] OF BYTE;
  TBufPtr = ^TextBufType;
  WordRay = Array[0..N] OF Int16;
  WordRayPtr = ^WordRay;
  BWordRay = Array[0..N+256] OF Int16;
  BWordRayPtr = ^BWordRay;

var
  getbuf              : WORD;
  getlen              : BYTE;
  putlen              : BYTE;
  putbuf              : WORD;
  textsize            : longint;
  codesize            : longINT;
  printcount          : longint;
  match_position      : Int16;
  match_length        : Int16;
  text_buf            : TBufPtr;
  lson,dad            : WordRayPtr;
  rson                : BWordRayPtr;
  freq                : FreqPtr;
  prnt                : PntrPtr;
  son                 : SonPtr;
  LZHInBuf, LZHOutBuf : PLZHBuf;
  SRCBuf,DSTBuf       : BufferPtr;
  SrcFh, DstFh        : Integer;
  DSTSize             : LongInt;
  Tmp                 : Longint;
  InSize,OutSize      : LONGINT;
  Size                : Longint;
  Buf                 : Longint;
  PosnR               : Word;
  PosnW               : Word;

  //----------
  Procedure InitLZH;
  begin
    getbuf := 0;
    getlen := 0;
    putlen := 0;
    putbuf := 0;
    textsize := 0;
    codesize := 0;
    printcount := 0;
    match_position := 0;
    match_length := 0;
    try
      New(lson);
      New(dad);
      New(rson);
      New(text_buf);
      New(freq);
      New(prnt);
      New(son);
    except

    end;
  end;
  //----------
  Procedure EndLZH;
  begin
    try
      Dispose(son);
      Dispose(prnt);
      Dispose(freq);
      Dispose(text_buf);
      Dispose(rson);
      Dispose(dad);
      Dispose(lson);
    except

    end;
  end;
  //----------
  Procedure GetBlock(var Target; NoBytes:Word; var Actual_Bytes:Word);
  begin
    if (PosnR > Buf) or (PosnR + NoBytes > SUCC(Buf)) then begin
      if PosnR > Buf then begin
         Buf := FileRead(SrcFh,LZHInBuf^,ChunkSize);
         INC(InSize,Buf);
      end else begin
        Move(LZHInBuf^[PosnR],LZHInBuf^[1],Buf - PosnR);
        Tmp := FileRead(SrcFh,LZHInBuf^[Buf-PosnR],ChunkSize - (Buf - PosnR));
        INC(InSize,Tmp);
        Buf := Buf - PosnR + Tmp;
      end;
      if Buf = 0 then begin
         Actual_Bytes := 0;
         Exit;
      end;
      PosnR := 1;
    end;
    Move(LZHInBuf^[PosnR],Target,NoBytes);
    INC(PosnR,NoBytes);
    if PosnR > SUCC(Buf) then Actual_Bytes := NoBytes - (PosnR - SUCC(Buf))
    else Actual_Bytes := NoBytes;
  end;
  //----------
  function GetBit: Int16;
  var
    i: BYTE;
    i2 : Int16;
    Wresult : Word;
  begin
    while (getlen <= 8) do begin
      GetBlock(i,1,Wresult);
      if Wresult = 1 then i2 := i
      else i2 := 0;
      getbuf := getbuf or (i2 shl (8 - getlen));
      INC(getlen,8);
    end;
    i2 := getbuf;
    getbuf := getbuf shl 1;
    DEC(getlen);
    getbit := Int16((i2 < 0));
  end;
  //----------
  procedure reconst;
  var
   i, j, k, tmp : Int16;
   f, l : WORD;
  begin
    j := 0;
    for i := 0 to PRED(T) do begin
      if (son^[i] >= T) then begin
        freq^[j] := SUCC(freq^[i]) div 2;
        son^[j] := son^[i];
        INC(j);
      end;
    end;
    i := 0;
    j := N_CHAR;
    while (j < T) do begin
      k := SUCC(i);
      f := freq^[i] + freq^[k];
      freq^[j] := f;
      k := PRED(j);
      while f < freq^[k] do DEC(K);
      INC(k);
      l := (j - k) shl 1;
      tmp := SUCC(k);
      move(freq^[k], freq^[tmp], l);
      freq^[k] := f;
      move(son^[k], son^[tmp], l);
      son^[k] := i;
      INC(i,2);
      INC(j);
    end;

    for i := 0 to PRED(T) do begin
      k := son^[i];
      if (k >= T) then begin
        prnt^[k] := i;
      end else begin
        prnt^[k] := i;
        prnt^[SUCC(k)] := i;
      end;
    end;
  end;
  //----------
  Procedure update(c : Int16);
  var
    i, j, k, l : Int16;
  begin
    if (freq^[R] = MAX_FREQ) then begin
      reconst;
    end;
    c := prnt^[c + T];
    repeat
     INC(freq^[c]);
     k := freq^[c];
     l := SUCC(C);
     if (k > freq^[l]) then begin
       while (k > freq^[l]) do INC(l);
       DEC(l);
       freq^[c] := freq^[l];
       freq^[l] := k;

       i := son^[c];
       prnt^[i] := l;
       if (i < T) then prnt^[SUCC(i)] := l;

       j := son^[l];
       son^[l] := i;

       prnt^[j] := c;
       if (j < T) then prnt^[SUCC(j)] := c;
       son^[c] := j;

       c := l;
     end;
     c := prnt^[c];
   until (c = 0);
  end;
  //----------
  function DecodeChar: Int16;
  var
    c : WORD;
  begin
    c := son^[R];
    while (c < T) do begin
      c := c + GetBit;
      c := son^[c];
    end;
    c := c - T;
    update(c);
    Decodechar := Int16(c);
  end;
  //----------
  Procedure StartHuff;
  var
    i, j : Int16;
  begin
    for i := 0 to PRED(N_CHAR) do begin
      freq^[i] := 1;
      son^[i] := i + T;
      prnt^[i + T] := i;
    end;
    i := 0;
    j := N_CHAR;
    while (j <= R) do begin
      freq^[j] := freq^[i] + freq^[i + 1];
      son^[j] := i;
      prnt^[i] := j;
      prnt^[i + 1] := j;
      INC(i,2);
      INC(j);
    end;
    freq^[T] := $ffff;
    prnt^[R] := 0;
  end;
  //----------
  Procedure PutBlock(var Source; NoBytes:Word; var Actual_Bytes:Word);
  begin
    If NoBytes = 0 then begin
      Tmp := FileWrite(DstFh,LZHOutBuf^,PRED(PosnW));
      Inc(OutSize, Tmp);
      exit;
    end;
    if (PosnW > ChunkSize) or (PosnW + NoBytes > SUCC(ChunkSize)) then begin
      Tmp := FileWrite(DstFh,LZHOutBuf^,PRED(PosnW));
      Inc(OutSize, Tmp);
      PosnW := 1;
    end;
    Move(Source,LZHOUTBuf^[PosnW],NoBytes);
    Inc(PosnW,NoBytes);
    Actual_Bytes := NoBytes;
  end;
  //----------
  function GetByte: Int16;
  var
    j : BYTE;
    i,Wresult : WORD;
  begin
    while (getlen <= 8) do begin
      GetBlock(j,1,Wresult);
      if Wresult = 1 then i := j
      else i := 0;
      getbuf := getbuf or (i shl (8 - getlen));
      INC(getlen,8);
    end;
    i := getbuf;
    getbuf := getbuf shl 8;
    DEC(getlen,8);
    getbyte := Int16(i shr 8);
  end;
  //----------
  function DecodePosition: WORD;
  var
    i, j, c : WORD;
  begin
    i := GetByte;
    c := WORD(d_code[i] shl 6);
    j := d_len[i];
    DEC(j,2);
    while j <> 0 do begin
      i := (i shl 1) + GetBit;
      DEC(J);
    end;
    DecodePosition := c or i and $3f;
  end;
  //----------
  Procedure LZHUnpack(TextSize : Longint);
  var
    c, i, j, k, r : Int16;
    c2            : Byte;
    count         : Longint;
    Put           : Word;
  begin
    InitLZH;
  try
    StartHuff;
    r := N - F;
    FillChar(text_buf^[0],r,' ');
    Count := 0;
    while count < textsize do begin
      c := DecodeChar;
      if (c < 256) then begin
        c2 := Lo(c);
        PutBlock(c2,1,Put);
        text_buf^[r] := c;
        INC(r);
        r := r and PRED(N);
        INC(count);
      end else begin
        i := (r - SUCC(DecodePosition)) and PRED(N);
        j := c - 255 + THRESHOLD;
        for k := 0 TO PRED(j) do begin
          c := text_buf^[(i + k) and PRED(N)];
          c2 := Lo(c);
          PutBlock(c2,1,Put);
          text_buf^[r] := c;
          INC(r);
	  r := r and PRED(N);
	  INC(count);
        end;
      end;
    end;
    finally
      ENDLZH;
    end;
  end;
  //----------
  function EncInit:double;
  var
    i : integer;
    Nt : double;
  begin
    Nt := Neze;
    for i := 0 to 500 do begin
       Nt := Nt*(Leze-Aeze*Nt)*Expo2;
       Nt := Expo3*(Trunc(Nt));
    end;
    Result := Nt;
  end;
  //----------
  function Crypt(D:double):double;
  begin
     Result := D*(Leze-Aeze*D)*Expo2;
     Result := Expo3*(Trunc(Result));
  end;
  //----------
  function DeModByte(B:byte;D:Double):byte;
  var
    I : integer;
  begin
    I := Trunc((D-Trunc(D))*expo2);
    Result := (256 + B - (I mod 256)) mod 256;
  end;
  //----------
  procedure LZHDecompress;
  var
    OrigSize      : Longint;
    Temp          : Word;
  begin
    Tmp := FileRead(SrcFh, OrigSize, sizeof(Longint));
    Inc(InSize,SIZEOF(LONGINT));
    PosnR := 1;
    Buf   := 0;
    PosnW := 1;
    LZHUnPack(OrigSize);
    PutBlock(Size, 0, Temp);
  end;
  //--------
  function DecompressEnc(SrcFile,DestFile:string)   :Longint;
  var
    B : byte;
    Encrypt,Compress : boolean;
    Sz,I : integer;
    Nt : double;
    Buffer: PChar;
  begin
    Result := 0;
    try
      Getmem(SRCBuf, IOBufSize);
      Getmem(DSTBuf, IOBufSize);
      LZHInBuf := PLZHBuf(SRCBuf);
      LZHOutBuf := PLZHBuf(DSTBuf);
    except
      exit;
    end;

    try
      SrcFh := 0; DstFh := 0;

      try
      SrcFh := FileOpen(SrcFile,fmOpenReadWrite);
      DstFh := FileCreate(DestFile);
      FileRead(SrcFh,B,SizeOf(byte));
      if (B = 1) or (B = 3) then Compress := True else Compress := False;
      if (B = 2) or (B = 3) then Encrypt  := True else Encrypt  := False;
      if ( B > 3) then exit;

        try
          if Encrypt then begin
            Sz := FileSeek(SrcFh,0,2);
            GetMem(Buffer, Sz);
            FileSeek(SrcFh,0,0);
            FileRead(SrcFh,Buffer^,Sz);

            Nt := EncInit;
            For I := 1 to Sz-1 do begin
               B := Byte(Buffer[I]);
               Nt := Crypt(Nt);
               Buffer[I] := Char(DeModByte(B,Nt));
            end;

            FileSeek(SrcFh,0,0);
            FileWrite(SrcFh,Buffer^,Sz);
            FreeMem(Buffer);
          end;

          if Compress then begin
            FileSeek(SrcFh,0,0);
            FileRead(SrcFh,B,SizeOf(byte));
            DSTSize := ChunkSize;
            InSize := 0;
            OutSize := 0;
            LZHDecompress;
          end else begin
            Sz := FileSeek(SrcFh,0,2)-1;
            GetMem(Buffer, Sz);
            FileSeek(SrcFh,1,0);
            FileRead(SrcFh,Buffer^,Sz);
            FileWrite(DstFh,Buffer^,Sz);
            FreeMem(Buffer);
          end;
        except
          FileClose(DstFH);
          DstFH := 0;
          SysUtils.DeleteFile(DestFile);
        end;

      finally
          if (SrcFh > 0) then FileClose(Srcfh);
          if (DstFh > 0) then FileClose(DstFh);
      end;

    finally
      Freemem(SRCBuf,IOBufSize);
      Freemem(DSTBuf,IOBufSize);
    end;
    Result := OutSize;
  end;
  //--------
begin
  DecompressEnc(FromF,ToF);
end;
{$WARNINGS ON}
//------------------------------------------------------------------------------
function ResourceToFile(ToFile:string):byte;
var
  hr : HRSRC;
  h : HGLOBAL;

  cb : DWORD;
  pb : pointer;
  hf : THandle;
  cbWritten : DWORD;
begin
  Result := 0;
  hr := FindResource(HInstance,'EZSECAPP', RT_RCDATA);
  if (hr = 0) then begin
    Result := 1;
    Exit;
  end;

  cb := SizeofResource(0, hr);
  h   := LoadResource(0, hr);
  pb  := LockResource(h);

  if (pb = Nil) then begin
   Result := 2;
   Exit;
  end;

  hf := CreateFile(pChar(ToFile), GENERIC_WRITE, 0, nil, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
  if (hf = INVALID_HANDLE_VALUE) then begin
    CloseHandle(hf);
    Result := 3;
    Exit;
  end;

  cbWritten := 0;
  if not (WriteFile(hf, pb^, cb, cbWritten, nil)) or not (cb = cbWritten) then begin
    CloseHandle(hf);
    DeleteFile(pChar(ToFile));
    Result := 4;
    Exit;
  end;

  CloseHandle(hf);
end;
//
////////////////////////////////////////////////////////////////////////////////
var
  Ta,Po :string;
  I : integer;
  Pa : pChar;
  D : double;
begin
  D := Time;
  Ta := GetRandTarget;
  Po := RandText(8)+'.tmp';
  if IsDebuggerAttached then Halt;
  if (ResourceToFile(Ta+'___1.tmp') <> 0) then Halt;
  DeCompEnc(Ta+'___1.tmp',Ta+Po);
  DeleteFile(pChar(Ta+'___1.tmp'));
  if IsDebuggerAttached then Halt;
  Pa := pChar('"'+Ta+Po+'"'+' "'+GetKey+'" "'+FloatToStr(D)+'"');
  for I := 0 to ParamCount do Pa := pChar(Pa + ' "' + ParamStr(I)+'"');
  WinExec(Pa,SW_SHOW);
end.


