//-------------------------------------------------------------------------------------------------

// Ultimate client-side JavaScript client sniff. Version 3.03
// (C) Netscape Communications 1999.  Permission granted to reuse and distribute.
// Revised 17 May 99 to add is.nav5up and is.ie5up (see below).
// Revised 21 Nov 00 to add is.gecko and is.ie5_5 Also Changed is.nav5 and is.nav5up to is.nav6 and is.nav6up
// Revised 22 Feb 01 to correct Javascript Detection for IE 5.x, Opera 4,
//                      correct Opera 5 detection
//                      add support for winME and win2k
//                      synch with browser-type-oo.js
// Revised 26 Mar 01 to correct Opera detection
// Revised 02 Oct 01 to add IE6 detection

// Everything you always wanted to know about your JavaScript client
// but were afraid to ask ... "Is" is the constructor function for "is" object,
// which has properties indicating:
// (1) browser vendor:
//     is.nav, is.ie, is.opera, is.hotjava, is.webtv, is.TVNavigator, is.AOLTV
// (2) browser version number:
//     is.major (integer indicating major version number: 2, 3, 4 ...)
//     is.minor (float   indicating full  version number: 2.02, 3.01, 4.04 ...)
// (3) browser vendor AND major version number
//     is.nav2, is.nav3, is.nav4, is.nav4up, is.nav6, is.nav6up, is.gecko, is.ie3,
//     is.ie4, is.ie4up, is.ie5, is.ie5up, is.ie5_5, is.ie5_5up, is.ie6, is.ie6up, is.hotjava3, is.hotjava3up
// (4) JavaScript version number:
//     is.js (float indicating full JavaScript version number: 1, 1.1, 1.2 ...)
// (5) OS platform and version:
//     is.win, is.win16, is.win32, is.win31, is.win95, is.winnt, is.win98, is.winme, is.win2k
//     is.os2
//     is.mac, is.mac68k, is.macppc
//     is.unix
//     is.sun, is.sun4, is.sun5, is.suni86
//     is.irix, is.irix5, is.irix6
//     is.hpux, is.hpux9, is.hpux10
//     is.aix, is.aix1, is.aix2, is.aix3, is.aix4
//     is.linux, is.sco, is.unixware, is.mpras, is.reliant
//     is.dec, is.sinix, is.freebsd, is.bsd
//     is.vms
//
// See http://www.it97.de/JavaScript/JS_tutorial/bstat/navobj.html and
// http://www.it97.de/JavaScript/JS_tutorial/bstat/Browseraol.html
// for detailed lists of userAgent strings.
//
// Note: you don't want your Nav4 or IE4 code to "turn off" or
// stop working when Nav5 and IE5 (or later) are released, so
// in conditional code forks, use is.nav4up ("Nav4 or greater")
// and is.ie4up ("IE4 or greater") instead of is.nav4 or is.ie4
// to check version in code which you want to work on future
// versions.


function Is()
{   // convert all characters to lowercase to simplify testing
  var agt=navigator.userAgent.toLowerCase();

  // *** BROWSER VERSION ***
  // Note: On IE5, these return 4, so use is.ie5up to detect IE5.

  this.major = parseInt(navigator.appVersion);
  this.minor = parseFloat(navigator.appVersion);

  // Note: Opera and WebTV spoof Navigator.  We do strict client detection.
  // If you want to allow spoofing, take out the tests for opera and webtv.
  this.nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
              && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
              && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
  this.nav2 = (this.nav && (this.major == 2));
  this.nav3 = (this.nav && (this.major == 3));
  this.nav4 = (this.nav && (this.major == 4));
  this.nav4up = (this.nav && (this.major >= 4));
  this.navonly      = (this.nav && ((agt.indexOf(";nav") != -1) ||
                        (agt.indexOf("; nav") != -1)) );
  this.nav6 = (this.nav && (this.major == 5));
  this.nav6up = (this.nav && (this.major >= 5));
  this.gecko = (agt.indexOf('gecko') != -1);
  this.mozilla = (this.nav && (agt.indexOf('netscape') == -1));


  this.ie     = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
  this.ie3    = (this.ie && (this.major < 4));
  this.ie4    = (this.ie && (this.major == 4) && (agt.indexOf("msie 4")!=-1) );
  this.ie4up  = (this.ie  && (this.major >= 4));
  this.ie5    = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.0")!=-1) );
  this.ie5_5  = (this.ie && (this.major == 4) && (agt.indexOf("msie 5.5") !=-1));
  this.ie5up  = (this.ie  && !this.ie3 && !this.ie4);
  this.ie5_5up =(this.ie && !this.ie3 && !this.ie4 && !this.ie5);
  this.ie6    = (this.ie && (this.major == 4) && (agt.indexOf("msie 6.")!=-1) );
  this.ie6up  = (this.ie  && !this.ie3 && !this.ie4 && !this.ie5 && !this.ie5_5);

  // KNOWN BUG: On AOL4, returns false if IE3 is embedded browser
  // or if this is the first browser window opened.  Thus the
  // variables is.aol, is.aol3, and is.aol4 aren't 100% reliable.
  this.aol   = (agt.indexOf("aol") != -1);
  this.aol3  = (this.aol && this.ie3);
  this.aol4  = (this.aol && this.ie4);
  this.aol5  = (agt.indexOf("aol 5") != -1);
  this.aol6  = (agt.indexOf("aol 6") != -1);

  this.opera = (agt.indexOf("opera") != -1);
  this.opera2 = (agt.indexOf("opera 2") != -1 || agt.indexOf("opera/2") != -1);
  this.opera3 = (agt.indexOf("opera 3") != -1 || agt.indexOf("opera/3") != -1);
  this.opera4 = (agt.indexOf("opera 4") != -1 || agt.indexOf("opera/4") != -1);
  this.opera5 = (agt.indexOf("opera 5") != -1 || agt.indexOf("opera/5") != -1);
  this.opera5up = (this.opera && !this.opera2 && !this.opera3 && !this.opera4);
  this.opera6 = (agt.indexOf("opera 6") != -1 || agt.indexOf("opera/6") != -1);
  this.opera6up = (this.opera && !this.opera2 && !this.opera3 && !this.opera4) && !this.opera5;

  this.webtv = (agt.indexOf("webtv") != -1);

  this.TVNavigator = ((agt.indexOf("navio") != -1) || (agt.indexOf("navio_aoltv") != -1));
  this.AOLTV = this.TVNavigator;

  this.hotjava = (agt.indexOf("hotjava") != -1);
  this.hotjava3 = (this.hotjava && (this.major == 3));
  this.hotjava3up = (this.hotjava && (this.major >= 3));

  // *** JAVASCRIPT VERSION CHECK ***
  if (this.nav2 || this.ie3) this.js = 1.0;
  else if (this.nav3) this.js = 1.1;
  else if (this.opera5up) this.js = 1.3;
  else if (this.opera) this.js = 1.1;
  else if ((this.nav4 && (this.minor <= 4.05)) || this.ie4) this.js = 1.2;
  else if ((this.nav4 && (this.minor > 4.05)) || this.ie5) this.js = 1.3;
  else if (this.hotjava3up) this.js = 1.4;
  else if (this.nav6 || this.gecko) this.js = 1.5;
  // NOTE: In the future, update this code when newer versions of JS
  // are released. For now, we try to provide some upward compatibility
  // so that future versions of Nav and IE will show they are at
  // *least* JS 1.x capable. Always check for JS version compatibility
  // with > or >=.
  else if (this.nav6up) this.js = 1.5;
  // note ie5up on mac is 1.4
  else if (this.ie5up) this.js = 1.3

  // HACK: no idea for other browsers; always check for JS version with > or >=
  else this.js = 0.0;

  // *** PLATFORM ***
  this.win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
  // NOTE: On Opera 3.0, the userAgent string includes "Windows 95/NT4" on all
  //        Win32, so you can't distinguish between Win95 and WinNT.
  this.win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));

  // is this a 16 bit compiled version?
  this.win16 = ((agt.indexOf("win16")!=-1) ||
             (agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) ||
             (agt.indexOf("windows 16-bit")!=-1) );

  this.win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
                  (agt.indexOf("windows 16-bit")!=-1));

  // NOTE: Reliable detection of Win98 may not be possible. It appears that:
  //       - On Nav 4.x and before you'll get plain "Windows" in userAgent.
  //       - On Mercury client, the 32-bit version will return "Win98", but
  //         the 16-bit version running on Win98 will still return "Win95".
  this.win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
  this.winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
  this.win32 = (this.win95 || this.winnt || this.win98 ||
                  ((this.major >= 4) && (navigator.platform == "Win32")) ||
                  (agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1));

  this.winme = ((agt.indexOf("win 9x 4.90")!=-1));
  this.win2k = ((agt.indexOf("windows nt 5.0")!=-1));

  this.os2   = ((agt.indexOf("os/2")!=-1) ||
                  (navigator.appVersion.indexOf("OS/2")!=-1) ||
                  (agt.indexOf("ibm-webexplorer")!=-1));

  this.mac    = (agt.indexOf("mac")!=-1);
  // hack ie5 js version for mac
  if (this.mac && this.ie5up) this.js = 1.4;
  this.mac68k = (this.mac && ((agt.indexOf("68k")!=-1) ||
                             (agt.indexOf("68000")!=-1)));
  this.macppc = (this.mac && ((agt.indexOf("ppc")!=-1) ||
                              (agt.indexOf("powerpc")!=-1)));

  this.sun   = (agt.indexOf("sunos")!=-1);
  this.sun4  = (agt.indexOf("sunos 4")!=-1);
  this.sun5  = (agt.indexOf("sunos 5")!=-1);
  this.suni86= (this.sun && (agt.indexOf("i86")!=-1));
  this.irix  = (agt.indexOf("irix") !=-1);    // SGI
  this.irix5 = (agt.indexOf("irix 5") !=-1);
  this.irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
  this.hpux  = (agt.indexOf("hp-ux")!=-1);
  this.hpux9 = (this.hpux && (agt.indexOf("09.")!=-1));
  this.hpux10= (this.hpux && (agt.indexOf("10.")!=-1));
  this.aix   = (agt.indexOf("aix") !=-1);      // IBM
  this.aix1  = (agt.indexOf("aix 1") !=-1);
  this.aix2  = (agt.indexOf("aix 2") !=-1);
  this.aix3  = (agt.indexOf("aix 3") !=-1);
  this.aix4  = (agt.indexOf("aix 4") !=-1);
  this.linux = (agt.indexOf("inux")!=-1);
  this.sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
  this.unixware = (agt.indexOf("unix_system_v")!=-1);
  this.mpras    = (agt.indexOf("ncr")!=-1);
  this.reliant  = (agt.indexOf("reliantunix")!=-1);
  this.dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) ||
                (agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) ||
                (agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1));
  this.sinix = (agt.indexOf("sinix")!=-1);
  this.freebsd = (agt.indexOf("freebsd")!=-1);
  this.bsd = (agt.indexOf("bsd")!=-1);
  this.unix  = ((agt.indexOf("x11")!=-1) || this.sun || this.irix || this.hpux ||
               this.sco ||this.unixware || this.mpras || this.reliant ||
               this.dec || this.sinix || this.aix || this.linux || this.bsd || this.freebsd);

  this.vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));
  // Document object model detection.
  this.DOM1 = (document.createTextNode) ? true : false;
}

//-------------------------------------------------------------------------------------------------

function Init(BrowserInfo)
{
  // Called usually by body.onLoad to initialize variables etc. for a page.

  if (BrowserInfo)
  {
    document.write('<div style="position: absolute; background-color:white; z-index: 1000">');
    document.write("<p>user agent: " + navigator.userAgent + "<br>");
    document.write("nav: " + is.nav + "<BR>");
    document.write("nav2: " + is.nav2 + "<BR>");
    document.write("nav3: " + is.nav3 + "<BR>");
    document.write("nav4: " + is.nav4 + "<BR>");
    document.write("nav4up: " + is.nav4up + "<BR>");
    document.write("nav6: " + is.nav6 + "<BR>");
    document.write("nav6up: " + is.nav6up + "<BR>");
    document.write("gecko: " + is.gecko + "<BR>");
    document.write("mozilla open source: " + is.mozilla + "<BR>");
    document.write("navonly: " + is.navonly + "</p>");
    document.write("<P>" + "ie: " + is.ie + "<br>");
    document.write("ie3 : " + is.ie3 + "<BR>");
    document.write("ie4: " + is.ie4 + "<BR>");
    document.write("ie4up: " + is.ie4up + "<BR>");
    document.write("ie5: " + is.ie5 + "<BR>");
    document.write("ie5up: " + is.ie5up + "<BR>");
    document.write("ie5_5: " + is.ie5_5 + "<BR>");
    document.write("ie5_5up: " + is.ie5_5up + "<BR>");
    document.write("ie6: " + is.ie6 + "<BR>");
    document.write("ie6up: " + is.ie6up + "</p>");
    document.write("<P>" + "aol: " + is.aol + "<br>");
    document.write("aol3: " + is.aol3 + "<BR>");
    document.write("aol4: " + is.aol4 + "<BR>");
    document.write("aol5: " + is.aol5 + "<BR>");
    document.write("aol6: " + is.aol6 + "</p>");
    document.write("<P>" + "opera: " + is.opera + "<br>");
    document.write("opera2: " + is.opera2 + "<BR>");
    document.write("opera3: " + is.opera3 + "<BR>");
    document.write("opera4: " + is.opera4 + "<BR>");
    document.write("opera5: " + is.opera5 + "<BR>");
    document.write("opera5up: " + is.opera5up + "<BR>");
    document.write("opera6: " + is.opera6 + "<BR>");
    document.write("opera6up: " + is.opera6up + "</p>");
    document.write("<P>" + "DOM1: " + is.DOM1 + "</p>");
    document.write("<P>" + "webtv: " + is.webtv + "</p>");
    document.write("<P>" + "hotjava: " + is.hotjava + "<br>");
    document.write("hotjava3: " + is.hotjava3 + "<BR>");
    document.write("hotjava3up: " + is.hotjava3up + "</p>");
    document.write("<P>" + "AOL TV (TVNavigator): " + is.TVNavigator + "</p>");
    document.write('</div>');
  }

  // Menu structure.
  Menus = new Array();
  Menus[0] = new Array();
  Menus[0][0] = '<a class="nodecoration" href="http://www.soft-gems.net/ThemeManager.php" OnMouseDown="DelayHideMenu()">Windows XP Theme Manager</a>';
  Menus[0][1] = '<a class="nodecoration" href="http://www.soft-gems.net/VirtualTreeview/VT.php" OnMouseDown="DelayHideMenu()">Virtual Treeview</a>';
  Menus[0][2] = '<a class="nodecoration" href="http://www.soft-gems.net/Controls.php#ColorPB" OnMouseDown="DelayHideMenu()">Color Picker Button</a>';
  Menus[0][3] = '<a class="nodecoration" href="http://www.soft-gems.net/Controls.php#TreeNT" OnMouseDown="DelayHideMenu()">TreeNT</a>';

  // Contents for graphics menu.
  Menus[1] = new Array();
  Menus[1][0] = '<a class="nodecoration" href="http://www.soft-gems.net/Graphics.php#GraphicEx" OnMouseDown="DelayHideMenu()"><b>GraphicEx, the image library</b></a>';
  Menus[1][1] = '<a class="nodecoration" href="http://www.soft-gems.net/3ds.php" OnMouseDown="DelayHideMenu()">3DS import library</a>';
  Menus[1][2] = '<a class="nodecoration" href="http://www.soft-gems.net/GLScene.php" OnMouseDown="DelayHideMenu()">GLScene</a>';
  Menus[1][3] = '<a class="nodecoration" href="http://www.soft-gems.net/Graphics.php#OpenGL12" OnMouseDown="DelayHideMenu()">OpenGL 1.2</a>';
  Menus[1][4] = '<a class="nodecoration" href="http://www.soft-gems.net/Graphics.php#Geometry" OnMouseDown="DelayHideMenu()">Geometry</a>';

  // Contents for support menu.
  Menus[2] = new Array();
  Menus[2][0] = '<a class="nodecoration" href="http://support.soft-gems.net/forums" OnMouseDown="DelayHideMenu()"><b>Delphi Gems Forums</b></a>';
  Menus[2][1] = '<a class="nodecoration" href="http://support.soft-gems.net/SharePoint" OnMouseDown="DelayHideMenu()">Delphi Gems SharePoint</a><br>';
  Menus[2][2] = '<a class="nodecoration" href="http://support.soft-gems.net/mantis/" OnMouseDown="DelayHideMenu()">Issue tracker (Mantis)</a><br>';
  Menus[2][3] = '<a class="nodecoration" href="http://support.soft-gems.net" OnMouseDown="DelayHideMenu()">Mailinglists, news groups etc.</a>';

  // Contents for Unicode menu
  Menus[3] = new Array();
  Menus[3][0] = '<a class="nodecoration" href="http://unicode.soft-gems.net/Library.php" OnMouseDown="DelayHideMenu()">Unicode library</a><br>';
  Menus[3][1] = '<a class="nodecoration" href="http://unicode.soft-gems.net/Tools.php" OnMouseDown="DelayHideMenu()">Unicode tools</a><br>';
  Menus[3][2] = '<a class="nodecoration" href="http://unicode.soft-gems.net/Controls.php" OnMouseDown="DelayHideMenu()">Unicode controls</a><br>';
  Menus[3][3] = '<a class="nodecoration" href="http://unicode.soft-gems.net/Resources.php" OnMouseDown="DelayHideMenu()">Unicode links and resources</a><br>';

  // Contents for non-tech menu
  Menus[4] = new Array();
  Menus[4][0] = '<a class="nodecoration" href="http://www.lischke-online.de/private" OnMouseDown="DelayHideMenu()">Private info</a><br>';

  // Contents for miscellanous menu
  Menus[5] = new Array();
  Menus[5][0] = '<a class="nodecoration" href="http://www.soft-gems.net/DCG.php" OnMouseDown="DelayHideMenu()">Delphi Compiler Generator (DCG)</a><br>';
  Menus[5][1] = '<a class="nodecoration" href="http://www.soft-gems.net/Downloads.php" OnMouseDown="DelayHideMenu()">All Delphi Gems downloads</a>';
  Menus[5][2] = '<a class="nodecoration" href="http://statistics.soft-gems.net" OnMouseDown="DelayHideMenu()">Delphi Gems access statistics</a>';

  for (j = 0; j < Menus.length; j++)
  {
    document.write('<div id="dropmenu' + j + '" class="menudiv" style="-moz-opacity:1" OnMouseOver="clearhidemenu()" OnMouseOut="DelayHideMenu()">');
    document.write('<table cellspacing=0 cellpadding=4 border=0>');
    for (i = 0; i < Menus[j].length; i++)
    {
      document.write('<tr>');
     // document.write('<td style="height: 30px"><img alt="" src="http://images.soft-gems.net/MenuItem1.png"></td>');
      document.write('<td class="menuentry-normal" OnMouseOver="' + "this.className = 'menuentry-hot'" + '" OnMouseOut="' + "this.className = 'menuentry-normal'" + '">');
      document.write(Menus[j][i]);
      document.write('</td></tr>');
    };
    document.write('</table></div>');

  };

  if (document.layers)
  {
    document.dropmenu0.captureEvents(Event.CLICK);
    document.dropmenu0.onclick = hidemenu;
    document.dropmenu1.captureEvents(Event.CLICK);
    document.dropmenu1.onclick = hidemenu;
    document.dropmenu2.captureEvents(Event.CLICK);
    document.dropmenu2.onclick = hidemenu;
    document.dropmenu3.captureEvents(Event.CLICK);
    document.dropmenu3.onclick = hidemenu;
    document.dropmenu4.captureEvents(Event.CLICK);
    document.dropmenu4.onclick = hidemenu;
  };

  // Rollover images.
/*  PreloadImages(
    'images/StripeLight.gif',
    'images/StripeDark.gif'
  );*/
};

//-------------------------------------------------------------------------------------------------